/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: ATUFORN_COMPRA                                                    */
/* Tabela : PRODCOMPRA, FORPRCOMPRA, COMPRA                                   */
/*                                                                            */
/* Criao:                                                                   */
/* 15/09/2006 - Raquel Cunha                                                  */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER ATUFORN_COMPRA
AFTER INSERT ON PRODCOMPRA FOR EACH ROW
DECLARE
  V_IDSITUCOMPRA VARCHAR2(1);
  V_FORNECEDOR   VARCHAR2(1);
  V_CDARVPROD    VARCHAR2(20);
  V_CDFILCENTCMP VARCHAR2(4);
BEGIN
   IF INSERTING THEN
      V_FORNECEDOR := 'N';
      SELECT
         IDSITUCOMPRA
      INTO
         V_IDSITUCOMPRA
      FROM
         COMPRA
      WHERE
         NRCOMPRA = :NEW.NRCOMPRA;
      SELECT NVL(MAX(FILIAL.CDFILCENTCMP), MAX(FILIAL.CDFILIAL))
        INTO V_CDFILCENTCMP
        FROM FILIAL
       WHERE FILIAL.CDFILIAL = :NEW.CDFILSOLI;
      IF V_IDSITUCOMPRA <> '6' AND
         V_IDSITUCOMPRA <> '7' THEN
         SELECT MAX(CDARVPROD)
           INTO V_CDARVPROD
           FROM PRODUTO
          WHERE CDPRODUTO = :NEW.CDPRODUTO;
         FOR C_FORNATENDE IN
             (SELECT
                PRODFORN.CDFORNECED
             FROM
                PRODFORN,
                PRODUTO,
             (
              SELECT
                 CDFORNECED
              FROM
                 FORNECEDOR,
                 QUALIFICACAO,
                 PARASUPRI
              WHERE
                 (FORNECEDOR.CDQUALIF = QUALIFICACAO.CDQUALIF(+)) AND
                 (PARASUPRI.CDFILIAL = V_CDFILCENTCMP) AND
                 (
                  (FORNECEDOR.CDQUALIF IS NULL) OR
                  (
                   (FORNECEDOR.CDQUALIF IS NOT NULL) AND
                   (
                    (QUALIFICACAO.IDPERCOTCMP = '1') OR
                    (QUALIFICACAO.IDPERCOTCMP = '2' AND FORNECEDOR.IDFORNAUTO = 'S')
                   ) AND
                   (
                    (PARASUPRI.IDULTIDTVALQ = 'D' AND
                     TO_DATE(SYSDATE) <= FORNECEDOR.DTVALQUALIF) OR
                    (PARASUPRI.IDULTIDTVALQ = 'M' AND
                     SYSDATE <= LAST_DAY(FORNECEDOR.DTVALQUALIF))
                   )
                  )
                 )

                 UNION

              SELECT
                 CDFORNECED
              FROM
                 FORNECEDOR,
                 QUALIFICACAO,
                 PARASUPRI
              WHERE
                 (FORNECEDOR.CDQUALIF IS NOT NULL) AND
                 (FORNECEDOR.CDQUALIF = QUALIFICACAO.CDQUALIF) AND
                 (PARASUPRI.CDFILIAL = V_CDFILCENTCMP) AND
                 (
                  (
                   (QUALIFICACAO.IDPERCOTCMP = '2' AND FORNECEDOR.IDFORNAUTO = 'N')
                  ) OR
                  (
                   (PARASUPRI.IDULTIDTVALQ = 'D' AND
                    TO_DATE(SYSDATE) > FORNECEDOR.DTVALQUALIF) OR
                   (PARASUPRI.IDULTIDTVALQ = 'M' AND
                    SYSDATE > LAST_DAY(FORNECEDOR.DTVALQUALIF))
                  )
                 )
             ) FORNECEDOR
             WHERE
                PRODFORN.CDPRODUTO = PRODUTO.CDPRODUTO AND
                PRODFORN.CDFORNECED = FORNECEDOR.CDFORNECED AND
                V_CDARVPROD LIKE PRODUTO.CDARVPROD || '%')
         LOOP
            V_FORNECEDOR := 'S';
            UPDATE
               FORPRCOMPRA
            SET
               IDSITUENVFOR = IDSITUENVFOR
            WHERE
               NRCOMPRA   = :NEW.NRCOMPRA            AND
               CDFORNECED = C_FORNATENDE.CDFORNECED;
            IF SQL%ROWCOUNT = 0 THEN
               INSERT INTO FORPRCOMPRA
                  (NRCOMPRA, CDFORNECED, IDSITUENVFOR)
               VALUES
                  (:NEW.NRCOMPRA, C_FORNATENDE.CDFORNECED, '2');
               UPDATE
                  COMPRA
               SET
                  IDSITUCOMPRA = '3'
               WHERE
                  NRCOMPRA = :NEW.NRCOMPRA;
            END IF;
         END LOOP;
         IF V_FORNECEDOR = 'N' THEN
            IF V_IDSITUCOMPRA = '1' THEN
               UPDATE
                  COMPRA
               SET
                  IDSITUCOMPRA = '2'
               WHERE
                  NRCOMPRA = :NEW.NRCOMPRA;
            END IF;
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUFORN_COMPRA','4.11.056'); END;
/

